/* 
 * File:   ConfigComboPopup.cpp
 * Author: Saleem EDAH-TALLY - nmset@yandex.com
 * License : LGPL
 * Copyright Saleem EDAH-TALLY - © 2017
 * 
 * Created on 3 mars 2017, 19:14
 */

#include "ConfigComboPopup.h"
#include "MiscTools.h"

ConfigComboPopup::ConfigComboPopup(TransientPopupComboEvent * evh)
{
    m_evh = evh;
}

ConfigComboPopup::~ConfigComboPopup()
{
    //cout << "DTOR :ConfigComboPopup"  << endl;
    delete m_evh;
}

void ConfigComboPopup::ShowTransientPopUp(wxControl * owner)
{
    m_popup = new PopupTransientWindow(owner);
    m_popup->Bind(wxEVT_DESTROY, &ConfigComboPopup::TransientPopupDestroy, this);
    m_pan = new wxPanel(m_popup);
    m_sz = new wxBoxSizer(wxVERTICAL);
    m_pan->SetSizer(m_sz);
    m_txtInfo = new wxTextCtrl(m_pan, wxID_ANY);
    m_sz->Add(m_txtInfo, 0, wxGROW | wxALL);
    m_txtInfo->SetToolTip(_("Short description"));
    m_szBtn = new wxBoxSizer(wxHORIZONTAL);
    m_sz->Add(m_szBtn, 0, wxGROW | wxALL);
    m_btnSave = new wxButton(m_pan, wxID_ANY, _("Save"));
    m_szBtn->Add(m_btnSave, 0, wxGROW | wxALL);
    m_btnSave->Bind(wxEVT_COMMAND_BUTTON_CLICKED, &ConfigComboPopup::TransientButtonSave, this);
    m_btnDelete = new wxButton(m_pan, wxID_ANY, _("Delete"));
    m_szBtn->Add(m_btnDelete, 0, wxGROW | wxALL);
    m_btnDelete->Bind(wxEVT_COMMAND_BUTTON_CLICKED, &ConfigComboPopup::TransientButtonDelete, this);
    m_sz->SetSizeHints(m_pan);
    m_evh->OnShow();
    MiscTools::ShowTransientPopup(m_popup, m_pan, m_pan->GetSize().GetWidth(), m_pan->GetSize().GetHeight());
}

void ConfigComboPopup::TransientButtonSave(wxCommandEvent& evt)
{
    m_evh->OnSave();
    m_btnSave->Disable();
    m_popup->Dismiss();
    m_popup->Destroy();
}

void ConfigComboPopup::TransientButtonDelete(wxCommandEvent& evt)
{
    m_evh->OnDelete();
    m_btnDelete->Disable();
    m_popup->Dismiss();
    m_popup->Destroy();
}

void ConfigComboPopup::TransientPopupDestroy(wxWindowDestroyEvent& evt)
{
    //cout << "TransientPopupDestroy" << endl;
}

void TransientPopupComboEvent::OnShow()
{
}

void TransientPopupComboEvent::OnSave()
{
}

void TransientPopupComboEvent::OnDelete()
{
}
