/* 
 * File:   DBusCB7Workers.cpp
 * Author: Saleem EDAH-TALLY - nmset@yandex.com
 * License : LGPL
 * Copyright Saleem EDAH-TALLY - © 2017
 * 
 * Created on 5 mars 2017, 15:18
 */

#include "gcc_version.h"
#include "DBusCB7Workers.h"

DBusCB7Adaptor::DBusCB7Adaptor(DBus::Connection &connection, XCB7 * owner)
: DBus::ObjectAdaptor(connection, "/Classeur/CB7")
/*
 * CB7 : OK
 * CB7-123 : dbus error, invalid name requested
 * something.CB7{,-123} : OK
 */
{
    m_owner = owner;
}

DBusCB7Adaptor::~DBusCB7Adaptor()
{
}

void DBusCB7Adaptor::Show(const bool& how)
{
    m_owner->Show(how);
}

DBusCB7AdaptorWorker::DBusCB7AdaptorWorker(DBus::Connection &connection, XCB7 * owner)
: wxThread(wxTHREAD_DETACHED)
{
    DBusCB7Adaptor * adaptor = new DBusCB7Adaptor(connection, owner);
}

DBusCB7AdaptorWorker::~DBusCB7AdaptorWorker()
{
    DBus::default_dispatcher->leave();
}

wxThread::ExitCode DBusCB7AdaptorWorker::Entry()
{
    DBus::default_dispatcher->enter(); // IS BLOCKING
    return 0;
}

DBusCB7Proxy::DBusCB7Proxy(DBus::Connection& connection, const char* service)
: DBus::ObjectProxy(connection, "/Classeur/CB7", service)
{

}

DBusCB7Proxy::~DBusCB7Proxy()
{
}


