/* 
 * File:   DBusFreeDesktop.cpp
 * Author: Saleem EDAH-TALLY - nmset@yandex.com
 * License : LGPL
 * Copyright Saleem EDAH-TALLY - © 2017
 * 
 * Created on November 1, 2018, 10:20 AM
 */

#include "DBusFreeDesktop.h"
#include "MiscTools.h"

DBusFreeDesktop::DBusFreeDesktop() {
}

DBusFreeDesktop::~DBusFreeDesktop() {
}

const vector<string> DBusFreeDesktop::GetRemoteInstances(const std::string& servicePrefix) {
    vector<string> result;
    
    static DBus::Connection bus = DBus::Connection::SessionBus();
    try {
        vector<string> list;
        DBusFreeDesktop_Proxy proxy(bus, "org.freedesktop.DBus");
        list = proxy.ListNames();
        vector<string>::iterator it;
        for (it = list.begin(); it != list.end(); it++) {
            if(it->substr(0, servicePrefix.length()) == servicePrefix)
                result.push_back(it->data());
        }
    }
    catch (DBus::Error e) {
        MiscTools::MessageBox(wxString(e.message()) + wxString("\n") +  wxString(e.name()), true);
    }
    return result;
}


DBusFreeDesktop_Proxy::DBusFreeDesktop_Proxy(DBus::Connection& connection, const char* service)
: DBus::ObjectProxy(connection, "/", service) {
        
}

DBusFreeDesktop_Proxy::~DBusFreeDesktop_Proxy() {

}
