/* 
 * File:   DBusFreeDesktop.h
 * Author: Saleem EDAH-TALLY - nmset@yandex.com
 * License : GPL
 * Copyright Saleem EDAH-TALLY - © 2017
 *
 * Created on November 1, 2018, 10:20 AM
 */

#ifndef DBUSFREEDESKTOP_H
#define DBUSFREEDESKTOP_H

#include "org_freedesktop_DBus_proxy.hpp"
#include <vector>
using namespace std;

class DBusFreeDesktop_Proxy;

/*
 * Gets a filtered list of services available at root of org.freedesktop.DBus.
 */

class DBusFreeDesktop {
public:
    DBusFreeDesktop();
    virtual ~DBusFreeDesktop();
    
    /**
     * Filter available services starting with a known common prefix,
     * like org.company.service-<pid>*,
     * if servicePrefix is passed as 'org.company.service-'.
     * 
     * @param servicePrefix
     * @return 
     */
    const vector<string> GetRemoteInstances(const std::string& servicePrefix);
    
private:

};

/**
 * The direct proxy to org.freedesktop.DBus.
 */
class DBusFreeDesktop_Proxy : public org::freedesktop::DBus_proxy,
        public DBus::IntrospectableProxy,
        public DBus::ObjectProxy {
public:
    DBusFreeDesktop_Proxy(DBus::Connection &connection, const char * service);
    virtual ~DBusFreeDesktop_Proxy();
    
};

#endif /* DBUSFREEDESKTOP_H */

