/////////////////////////////////////////////////////////////////////////////
// Name:        cb7.cpp
// Purpose:     
// Author:      Saleem EDAH-TALLY - nmset@yandex.com
// Modified by: 
// Created:     lun. 27 févr. 2017 21:57:00 CET
// RCS-ID:      
// Copyright:   Saleem EDAH-TALLY - © 2017
// Licence:     GPL
/////////////////////////////////////////////////////////////////////////////

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
////@end includes

#include "cb7.h"

////@begin XPM images
////@end XPM images


/*
 * CB7 type definition
 */

IMPLEMENT_CLASS( CB7, wxFrame )


/*
 * CB7 event table definition
 */

BEGIN_EVENT_TABLE( CB7, wxFrame )

////@begin CB7 event table entries
////@end CB7 event table entries

END_EVENT_TABLE()


/*
 * CB7 constructors
 */

CB7::CB7()
{
    Init();
}

CB7::CB7( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Init();
    Create( parent, id, caption, pos, size, style );
}


/*
 * CB7 creator
 */

bool CB7::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CB7 creation
    wxFrame::Create( parent, id, caption, pos, size, style );

    CreateControls();
    Centre();
////@end CB7 creation
    return true;
}


/*
 * CB7 destructor
 */

CB7::~CB7()
{
////@begin CB7 destruction
////@end CB7 destruction
}


/*
 * Member initialisation
 */

void CB7::Init()
{
////@begin CB7 member initialisation
    scrMain = NULL;
    szMain = NULL;
    lblRepository = NULL;
    dpkRepository = NULL;
    lblYear = NULL;
    spnYear = NULL;
    lblFolder = NULL;
    cmbFolder = NULL;
    lblLabel = NULL;
    cmbLabel = NULL;
    lblHint = NULL;
    cmbHint = NULL;
    lblFormat = NULL;
    cmbFormat = NULL;
    paneFiles = NULL;
    szPane = NULL;
    cbMove = NULL;
    cbTimeStamp = NULL;
    cbAppendName = NULL;
    cbPreferOriginal = NULL;
    btnSelectFile = NULL;
    btnAbout = NULL;
    btnRefresh = NULL;
    cmbScanners = NULL;
    txtResults = NULL;
    lblNewDoc = NULL;
    txtNewDoc = NULL;
    btnScan = NULL;
////@end CB7 member initialisation
}


/*
 * Control creation for CB7
 */

void CB7::CreateControls()
{    
////@begin CB7 content construction
    CB7* itemFrame1 = this;

    scrMain = new wxScrolledWindow( itemFrame1, ID_SCROLLEDWINDOW, wxDefaultPosition, wxSize(400, 300), wxHSCROLL|wxVSCROLL );
    scrMain->SetScrollbars(1, 1, 0, 0);
    szMain = new wxBoxSizer(wxVERTICAL);
    scrMain->SetSizer(szMain);

    wxBoxSizer* itemBoxSizer4 = new wxBoxSizer(wxHORIZONTAL);
    szMain->Add(itemBoxSizer4, 0, wxGROW|wxALL, 5);
    lblRepository = new wxStaticText( scrMain, ID_Repository_LBL, _("Document root"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer4->Add(lblRepository, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    dpkRepository = new wxDirPickerCtrl( scrMain, ID_Repository_DPK, wxEmptyString, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDIRP_DEFAULT_STYLE|wxDIRP_USE_TEXTCTRL|wxDIRP_DIR_MUST_EXIST|wxDIRP_SMALL );
    if (CB7::ShowToolTips())
        dpkRepository->SetToolTip(_("Double click to open in the default file manager."));
    itemBoxSizer4->Add(dpkRepository, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxBoxSizer* itemBoxSizer7 = new wxBoxSizer(wxHORIZONTAL);
    szMain->Add(itemBoxSizer7, 1, wxGROW|wxALL, 5);
    wxFlexGridSizer* itemFlexGridSizer8 = new wxFlexGridSizer(5, 2, 0, 0);
    itemBoxSizer7->Add(itemFlexGridSizer8, 2, wxGROW|wxALL, 5);
    lblYear = new wxStaticText( scrMain, ID_Year_LBL, _("Year"), wxDefaultPosition, wxDefaultSize, 0 );
    itemFlexGridSizer8->Add(lblYear, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    spnYear = new wxSpinCtrl( scrMain, ID_Year_SPN, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxSP_ARROW_KEYS, 2007, 2050, 2007 );
    if (CB7::ShowToolTips())
        spnYear->SetToolTip(_("When the document was established."));
    itemFlexGridSizer8->Add(spnYear, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    lblFolder = new wxStaticText( scrMain, ID_Folder_LBL, _("Folder"), wxDefaultPosition, wxDefaultSize, 0 );
    if (CB7::ShowToolTips())
        lblFolder->SetToolTip(_("Company, group, institution..."));
    itemFlexGridSizer8->Add(lblFolder, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxArrayString cmbFolderStrings;
    cmbFolder = new wxComboBox( scrMain, ID_Folder_CMB, wxEmptyString, wxDefaultPosition, wxDefaultSize, cmbFolderStrings, wxCB_DROPDOWN|wxCB_SORT );
    itemFlexGridSizer8->Add(cmbFolder, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    lblLabel = new wxStaticText( scrMain, ID_Label_LBL, _("Label"), wxDefaultPosition, wxDefaultSize, 0 );
    if (CB7::ShowToolTips())
        lblLabel->SetToolTip(_("Invoice, notice, check, contract..."));
    itemFlexGridSizer8->Add(lblLabel, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxArrayString cmbLabelStrings;
    cmbLabel = new wxComboBox( scrMain, ID_Label_CMB, wxEmptyString, wxDefaultPosition, wxDefaultSize, cmbLabelStrings, wxCB_DROPDOWN|wxCB_SORT );
    itemFlexGridSizer8->Add(cmbLabel, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    lblHint = new wxStaticText( scrMain, ID_Hint_LBL, _("Hint"), wxDefaultPosition, wxDefaultSize, 0 );
    if (CB7::ShowToolTips())
        lblHint->SetToolTip(_("Addition hint for the document content."));
    itemFlexGridSizer8->Add(lblHint, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxArrayString cmbHintStrings;
    cmbHint = new wxComboBox( scrMain, ID_Hint_CMB, wxEmptyString, wxDefaultPosition, wxDefaultSize, cmbHintStrings, wxCB_DROPDOWN|wxCB_SORT );
    itemFlexGridSizer8->Add(cmbHint, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    lblFormat = new wxStaticText( scrMain, ID_Format_LBL, _("Extension"), wxDefaultPosition, wxDefaultSize, 0 );
    if (CB7::ShowToolTips())
        lblFormat->SetToolTip(_("Extension of the created file."));
    itemFlexGridSizer8->Add(lblFormat, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxArrayString cmbFormatStrings;
    cmbFormat = new wxComboBox( scrMain, ID_Format_CMB, wxEmptyString, wxDefaultPosition, wxDefaultSize, cmbFormatStrings, wxCB_DROPDOWN|wxCB_SORT );
    itemFlexGridSizer8->Add(cmbFormat, 0, wxGROW|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    itemFlexGridSizer8->AddGrowableCol(1);

    paneFiles = new wxCollapsiblePane( scrMain, ID_Files_PANE, _("Files on storage"), wxDefaultPosition, wxDefaultSize, wxCP_DEFAULT_STYLE );
    if (CB7::ShowToolTips())
        paneFiles->SetToolTip(_("Drag and drop files here."));
    itemBoxSizer7->Add(paneFiles, 0, wxGROW|wxALL, 5);
    szPane = new wxBoxSizer(wxVERTICAL);
    paneFiles->GetPane()->SetSizer(szPane);

    cbMove = new wxCheckBox( paneFiles->GetPane(), ID_Move_CB, _("Move"), wxDefaultPosition, wxDefaultSize, wxCHK_2STATE );
    cbMove->SetValue(false);
    if (CB7::ShowToolTips())
        cbMove->SetToolTip(_("Move or copy dropped files."));
    szPane->Add(cbMove, 0, wxALIGN_LEFT|wxALL, 0);

    cbTimeStamp = new wxCheckBox( paneFiles->GetPane(), ID_TimeStamp, _("With timestamp"), wxDefaultPosition, wxDefaultSize, 0 );
    cbTimeStamp->SetValue(true);
    if (CB7::ShowToolTips())
        cbTimeStamp->SetToolTip(_("UNIX time. Prevents file name collisions."));
    szPane->Add(cbTimeStamp, 0, wxALIGN_LEFT|wxALL, 0);

    cbAppendName = new wxCheckBox( paneFiles->GetPane(), ID_AppendName, _("Append file name"), wxDefaultPosition, wxDefaultSize, 0 );
    cbAppendName->SetValue(false);
    if (CB7::ShowToolTips())
        cbAppendName->SetToolTip(_("Append the original file name."));
    szPane->Add(cbAppendName, 0, wxALIGN_LEFT|wxALL, 0);

    cbPreferOriginal = new wxCheckBox( paneFiles->GetPane(), ID_PreferOriginal, _("Don't rename"), wxDefaultPosition, wxDefaultSize, 0 );
    cbPreferOriginal->SetValue(false);
    if (CB7::ShowToolTips())
        cbPreferOriginal->SetToolTip(_("File is written with exact original name."));
    szPane->Add(cbPreferOriginal, 0, wxALIGN_LEFT|wxALL, 0);

    wxBoxSizer* itemBoxSizer25 = new wxBoxSizer(wxHORIZONTAL);
    szPane->Add(itemBoxSizer25, 0, wxGROW|wxALL, 5);
    btnSelectFile = new wxButton( paneFiles->GetPane(), ID_SelectFile, _("Select"), wxDefaultPosition, wxDefaultSize, 0 );
    if (CB7::ShowToolTips())
        btnSelectFile->SetToolTip(_("Select one or many files."));
    itemBoxSizer25->Add(btnSelectFile, 0, wxALIGN_CENTER_VERTICAL|wxALL, 0);

    btnAbout = new wxButton( paneFiles->GetPane(), ID_About_BTN, _("About"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer25->Add(btnAbout, 0, wxALIGN_CENTER_VERTICAL|wxALL, 0);

    wxBoxSizer* itemBoxSizer28 = new wxBoxSizer(wxHORIZONTAL);
    szMain->Add(itemBoxSizer28, 0, wxGROW|wxALL, 5);
    btnRefresh = new wxButton( scrMain, ID_Refresh, _("Refresh"), wxDefaultPosition, wxDefaultSize, 0 );
    if (CB7::ShowToolTips())
        btnRefresh->SetToolTip(_("Refresh list of available scanners"));
    itemBoxSizer28->Add(btnRefresh, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxArrayString cmbScannersStrings;
    cmbScanners = new wxComboBox( scrMain, ID_Scanners, wxEmptyString, wxDefaultPosition, wxDefaultSize, cmbScannersStrings, wxCB_READONLY );
    if (CB7::ShowToolTips())
        cmbScanners->SetToolTip(_("Available scanners"));
    itemBoxSizer28->Add(cmbScanners, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    txtResults = new wxTextCtrl( scrMain, ID_Results, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxTE_READONLY );
    if (CB7::ShowToolTips())
        txtResults->SetToolTip(_("Results on move/copy existing files."));
    szMain->Add(txtResults, 1, wxGROW|wxALL, 5);

    wxBoxSizer* itemBoxSizer32 = new wxBoxSizer(wxHORIZONTAL);
    szMain->Add(itemBoxSizer32, 0, wxGROW|wxALL, 5);
    lblNewDoc = new wxStaticText( scrMain, ID_NewDoc_LBL, _("New"), wxDefaultPosition, wxDefaultSize, 0 );
    if (CB7::ShowToolTips())
        lblNewDoc->SetToolTip(_("Click to generate a new destination file name.\nRight click for counter options."));
    itemBoxSizer32->Add(lblNewDoc, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    txtNewDoc = new wxTextCtrl( scrMain, ID_NewDoc_TXT, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxTE_READONLY );
    if (CB7::ShowToolTips())
        txtNewDoc->SetToolTip(_("Full destination file name, with an appended counter."));
    itemBoxSizer32->Add(txtNewDoc, 1, wxGROW|wxALL, 5);

    btnScan = new wxButton( scrMain, ID_Scan_BTN, _("Scan"), wxDefaultPosition, wxDefaultSize, 0 );
    if (CB7::ShowToolTips())
        btnScan->SetToolTip(_("Start document scan."));
    itemBoxSizer32->Add(btnScan, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    scrMain->FitInside();

////@end CB7 content construction
}


/*
 * Should we show tooltips?
 */

bool CB7::ShowToolTips()
{
    return true;
}

/*
 * Get bitmap resources
 */

wxBitmap CB7::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CB7 bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CB7 bitmap retrieval
}

/*
 * Get icon resources
 */

wxIcon CB7::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CB7 icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CB7 icon retrieval
}
