/////////////////////////////////////////////////////////////////////////////
// Name:        cb7.h
// Purpose:     
// Author:      Saleem EDAH-TALLY - nmset@yandex.com
// Modified by: 
// Created:     lun. 27 févr. 2017 21:57:00 CET
// RCS-ID:      
// Copyright:   Saleem EDAH-TALLY - © 2017
// Licence:     GPL
/////////////////////////////////////////////////////////////////////////////

#ifndef _CB7_H_
#define _CB7_H_


/*!
 * Includes
 */

////@begin includes
#include "wx/frame.h"
#include "wx/filepicker.h"
#include "wx/spinctrl.h"
#include "wx/collpane.h"
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxBoxSizer;
class wxDirPickerCtrl;
class wxSpinCtrl;
class wxCollapsiblePane;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_CB7 10000
#define ID_SCROLLEDWINDOW 10001
#define ID_Repository_LBL 10010
#define ID_Repository_DPK 10009
#define ID_Year_LBL 10011
#define ID_Year_SPN 10002
#define ID_Folder_LBL 10012
#define ID_Folder_CMB 10003
#define ID_Label_LBL 10013
#define ID_Label_CMB 10004
#define ID_Hint_LBL 10024
#define ID_Hint_CMB 10023
#define ID_Format_LBL 10017
#define ID_Format_CMB 10016
#define ID_Files_PANE 10020
#define ID_Move_CB 10015
#define ID_TimeStamp 10007
#define ID_AppendName 10018
#define ID_PreferOriginal 10019
#define ID_SelectFile 10021
#define ID_About_BTN 10008
#define ID_Refresh 10025
#define ID_Scanners 10026
#define ID_Results 10022
#define ID_NewDoc_LBL 10014
#define ID_NewDoc_TXT 10005
#define ID_Scan_BTN 10006
#define SYMBOL_CB7_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxMINIMIZE_BOX|wxCLOSE_BOX
#define SYMBOL_CB7_TITLE _("Classeur de bureau")
#define SYMBOL_CB7_IDNAME ID_CB7
#define SYMBOL_CB7_SIZE wxSize(450, 550)
#define SYMBOL_CB7_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CB7 class declaration
 */

class CB7: public wxFrame
{    
    DECLARE_CLASS( CB7 )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CB7();
    CB7( wxWindow* parent, wxWindowID id = SYMBOL_CB7_IDNAME, const wxString& caption = SYMBOL_CB7_TITLE, const wxPoint& pos = SYMBOL_CB7_POSITION, const wxSize& size = SYMBOL_CB7_SIZE, long style = SYMBOL_CB7_STYLE );

    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CB7_IDNAME, const wxString& caption = SYMBOL_CB7_TITLE, const wxPoint& pos = SYMBOL_CB7_POSITION, const wxSize& size = SYMBOL_CB7_SIZE, long style = SYMBOL_CB7_STYLE );

    /// Destructor
    ~CB7();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CB7 event handler declarations

////@end CB7 event handler declarations

////@begin CB7 member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CB7 member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CB7 member variables
    wxScrolledWindow* scrMain;
    wxBoxSizer* szMain;
    wxStaticText* lblRepository;
    wxDirPickerCtrl* dpkRepository;
    wxStaticText* lblYear;
    wxSpinCtrl* spnYear;
    wxStaticText* lblFolder;
    wxComboBox* cmbFolder;
    wxStaticText* lblLabel;
    wxComboBox* cmbLabel;
    wxStaticText* lblHint;
    wxComboBox* cmbHint;
    wxStaticText* lblFormat;
    wxComboBox* cmbFormat;
    wxCollapsiblePane* paneFiles;
    wxBoxSizer* szPane;
    wxCheckBox* cbMove;
    wxCheckBox* cbTimeStamp;
    wxCheckBox* cbAppendName;
    wxCheckBox* cbPreferOriginal;
    wxButton* btnSelectFile;
    wxButton* btnAbout;
    wxButton* btnRefresh;
    wxComboBox* cmbScanners;
    wxTextCtrl* txtResults;
    wxStaticText* lblNewDoc;
    wxTextCtrl* txtNewDoc;
    wxButton* btnScan;
////@end CB7 member variables
};

#endif
    // _CB7_H_
