#!/bin/bash
if [ ! -x pack.sh ]
then
    echo "Wrong working directory. Please cd to the directory containing this script."
    exit 0
fi

if [ $# = 0 ];then
    echo "\$1  -  CB7 version."
    exit 0
fi

#Clean default build
rm -fR ../build

cd ..

#Clean PKGBUILD directories
rm -f cb7-*.pkg.tar.xz
rm -fR src pkg

#Remove previous source package
rm -f cb7-*.tar.gz

#Clean Lokalize compiled and backup files
find ./Resources/Lokalize -type f -name "CB7.po.bak-*" -exec rm -f {} \;
find ./Resources/Lokalize -type f -name "*.mo" -exec rm -f {} \;

#Standard packing
cd -
cd ../../
tar --exclude=".git*" --exclude"=.kdev4" -czf /tmp/cb7-$1.tar.gz CB7
mv /tmp/cb7-$1.tar.gz CB7/
cd -

exit 0
