/* 
 * File:   TimeredStatusBar.h
 * Author: Saleem EDAH-TALLY - nmset@yandex.com
 * License : GPL
 * Copyright Saleem EDAH-TALLY - © 2017
 *
 * Created on April 22, 2018, 3:55 PM
 */

#ifndef TIMEREDSTATUSBAR_H
#define TIMEREDSTATUSBAR_H

#include <wx/wx.h>
#include <wx/timer.h>

/**
 * We want to show a transient message.
 * The widget show also CAPS and NUM status.
 * @param parent
 * @param clearAfter
 */
class TimeredStatusBar : public wxStatusBar
{
public:
    TimeredStatusBar(wxWindow * parent, const uint clearAfter = 3000);
    virtual ~TimeredStatusBar();

    /**
     * Called by the application to display 'text' transiently.
     * @param text
     */
    void SetTransientText(const wxString& text);
    void OnIdle(wxIdleEvent& evt);
private:
    uint m_clearAfter;
    uint m_numFields;
    wxTimer m_timer;
    void OnTimer(wxTimerEvent& evt);
};

#endif /* TIMEREDSTATUSBAR_H */

